### Cargando librerias o paquetes  ############################################################


### Cargar librerias
library(dplyr)
library(PerformanceAnalytics)
##library(xlsx)
library(MASS)
library(rpart.plot)
library(ROCR)
library(ResourceSelection)
library(pROC)
library(rpart)
library(readxl)
library(rpart)
library(rpart.plot)
library(car)
library(ROCR)
library(InformationValue)


#######################################

class(datos1)
datos1<-as.data.frame(datos1)
class(datos1)
names(datos1)

windows()
boxplot(datos1$UN_Patrimonio~datos1$Default,
        main="Boxplot para la Utilidad Neta / Patrimonio (%)",
        xlab="Default",ylab="Utilidad Neta / Patrimonio (%)",
        cex.lab="1.2",col="#00BFFF")

windows()
boxplot(datos1$Dias_Cartera~datos1$Default,
        main="Boxplot para D?as de Cartera",
        xlab="Default",ylab="D?as de Cartera",
        cex.lab="1.2",col="#00BFFF")

windows()
boxplot(datos1$Relacion_Corriente~datos1$Default,
        main="Boxplot para la Relacin Corriente",
        xlab="Default",ylab="Relacin Corriente",
        cex.lab="1.2",col="#00BFFF")


windows()
boxplot(datos1$PIB~datos1$Default,
        main="Boxplot para la Variaci?n anual del PIB(%)",
        xlab="Default",ylab="Variaci?n anual del PIB(%)",
        cex.lab="1.2",col="#00BFFF")

windows()
boxplot(datos1$Tasa_Desempleo~datos1$Default,
        main="Boxplot para la Tasa de desempleo(%)",
        xlab="Default",ylab="Tasa de desempleo(%)",
        cex.lab="1.2",col="#00BFFF")


windows()
boxplot(datos1$Mora_Anual~datos1$Default,
        main="Boxplot para la Mxima mora anual",
        xlab="Default",ylab="Mxima mora anual",
        cex.lab="1.2",col="#00BFFF")


arbol1<-rpart(datos1$Default~datos1$UN_Patrimonio,method="class")
rpart.plot(arbol1)

########################### separando bases de entrenamiento y validar

numero_aleatori<-c(1:30141)

#El 80% de 30141 firmas equivale a 24113
set.seed(123)
muestra80<- sample(numero_aleatori,24113,replace = FALSE)

entrenamiento<-datos1[muestra80,]
entrenamiento
validacion<-datos1[-c(muestra80),]
summary(entrenamiento)

summary(datos1)
###############################################################################################
#####  MODELO LOGIT #########################################################################

Modelo_ajustado<-entrenamiento[c(5,6,7,8,10,11,12,13,16,18)]
str(Modelo_ajustado)
summary(Modelo_ajustado)
Modelo_ajustado$Default<-as.numeric(Modelo_ajustado$Default)
logit<- glm(entrenamiento$Default~. ,data=Modelo_ajustado, family=(binomial(link=logit)))
summary(logit)
vif(logit)

# modelo_elej<-stepAIC(logit16_1,direction = "both")
# logit16_1<-modelo_elej
# summary(modelo_elej)

#############################################3
prediccion<-predict(logit)
Modelo_ajustado$pi_calculada<-1/(1+exp(-predict(logit)))
summary(Modelo_ajustado$pi_calculada)

length(Modelo_ajustado$Default)
sum(Modelo_ajustado$Default)

sum(Modelo_ajustado$Default)/length(Modelo_ajustado$Default)


sensitivity(Modelo_ajustado$Default, Modelo_ajustado$pi_calculada, threshold = 0.50)

specificity(Modelo_ajustado$Default, Modelo_ajustado$pi_calculada, threshold = 0.50)


#matriz <- optimalCutoff(Modelo_ajustado$Default, Modelo_ajustado$pi_calculada)
#sensitivity(Modelo_ajustado$Default, Modelo_ajustado$pi_calculada, threshold = matriz)
#specificity(Modelo_ajustado$Default, Modelo_ajustado$pi_calculada, threshold = matriz)
            
######### CURVA ROC
windows()
AUC<-plot(roc(Modelo_ajustado$Default,Modelo_ajustado$pi_calculada),print.auc=T,ylab="Sensibilidad",xlab="Especificidad",main="Grfico area bajo la curva ROC ")
auc <-AUC$auc
auc
AR <- (auc-0.5)*2
AR*100

#### EFECTOS MARGINALES #########################################
logitvec <- mean(dlogis(predict(logit, type = "link")))
efecto<- data.frame(logitvec * coef(logit));names(efecto)<-c("Efecto Marginal (%)");efecto
round(efecto*100,8)

################################################################################################
###############################################################################################
#####  BACKTESTING #########################################################################

validacion
class(validacion)

###########################################################################
## MODELO AJUSTADO  #######################################################
Modelo_Validacion<-validacion[c(5,6,7,8,10,11,12,13,16,18)];names(Modelo_Validacion)
str(Modelo_Validacion)
################################################################################################
## COEFICIENTES DE MODELO 1 
round(logit$coefficients,digits = 6)
coeficientes<-paste0("b",seq(1,9),"<-")


data.frame(c("Intercepto2<-",coeficientes),round(logit$coefficients,digits = 6))

Intercepto2<- -11.168656
b1<- -0.036483
b2<- 0.002836
b3<- -0.139965
b4<- 0.008760
b5<- 0.829923
b6<- 1.140452
b7<- -0.245503
b8<- 0.750915
b9<- 0.013394

######### VALIDACION ###################################################################
str(Modelo_Validacion)

Modelo_Validacion$Valor_Z <- Intercepto2 +
  (b1 * Modelo_Validacion$UN_Patrimonio)+
  (b2 * Modelo_Validacion$Dias_Cartera) +
  (b3 * Modelo_Validacion$Relacion_Corriente)+
  (b4 * Modelo_Validacion$Obligaciones_Bancarias_Pasivo_Total)+
  (b5 * Modelo_Validacion$Mediana)+
  (b6 * Modelo_Validacion$Pequea)+
  (b7 * Modelo_Validacion$PIB)+
  (b8 * Modelo_Validacion$Tasa_Desempleo)+
  (b9 * Modelo_Validacion$Mora_Anual)


## Calculo de PI
Modelo_Validacion$pi_calculada<- (1/(1+exp(-(Modelo_Validacion$Valor_Z))))
summary(Modelo_Validacion$pi_calculada)
### Calculo AUC
windows()
AUC2<-plot(roc(Modelo_Validacion$Default,Modelo_Validacion$pi_calculada),print.auc=T,ylab="Sensibilidad",xlab="Especificidad",main="Grfico area bajo la curva ROC ")
auc2 <-AUC2$auc
auc2
AR2 <- (auc2-0.5)*2
AR2*100


sensitivity(Modelo_Validacion$Default, Modelo_Validacion$pi_calculada, threshold = 0.50)

specificity(Modelo_Validacion$Default, Modelo_Validacion$pi_calculada, threshold = 0.50)


#matriz_validacion <- optimalCutoff(Modelo_Validacion$Default, Modelo_Validacion$pi_calculada)
#sensitivity(Modelo_Validacion$Default, Modelo_Validacion$pi_calculada, threshold = matriz_validacion)
#specificity(Modelo_Validacion$Default, Modelo_Validacion$pi_calculada, threshold = matriz_validacion)

######### BACKTESTING ###################################################################

##datos2<-read_xlsx(path =ruta_datos,sheet = "Backtesting" )  
class(datos2)
datos2<-as.data.frame(datos2)
class(datos2)
names(datos2)
length(datos2$Default)

Modelo_Backtesting<-datos2[c(5,6,7,8,10,11,12,13,16,18)]
names(Modelo_Backtesting)

Modelo_Backtesting$Valor_Z <- Intercepto2 +
  (b1 * Modelo_Backtesting$UN_Patrimonio)+
  (b2 * Modelo_Backtesting$Dias_Cartera) +
  (b3 * Modelo_Backtesting$Relacion_Corriente)+
  (b4 * Modelo_Backtesting$Obligaciones_Bancarias_Pasivo_Total)+
  (b5 * Modelo_Backtesting$Mediana)+
  (b6 * Modelo_Backtesting$Pequea)+
  (b7 * Modelo_Backtesting$PIB)+
  (b8 * Modelo_Backtesting$Tasa_Desempleo)+
  (b9 * Modelo_Backtesting$Mora_Anual)

Modelo_Backtesting$pi_calculada<- (1/(1+exp(-(Modelo_Backtesting$Valor_Z))))

mean(Modelo_Backtesting$pi_calculada)

### Calculo AUC
windows()
AUC3<-plot(roc(Modelo_Backtesting$Default,Modelo_Backtesting$pi_calculada),print.auc=T,ylab="Sensibilidad",xlab="Especificidad")
auc3 <-AUC3$auc
auc3
AR3 <- (auc3-0.5)*2
AR3*100

probabilidad_modelacion<-sum(entrenamiento$Default)/length(entrenamiento$Default)
probabilidad_modelacion

probabilidad_validacion<-sum(validacion$Default)/length(validacion$Default)
probabilidad_validacion

probabilidad_Backtesting<-sum(datos2$Default)/length(datos2$Default)
probabilidad_Backtesting

Modelo_Backtesting$Grupo <- ifelse(Modelo_Backtesting$pi_calculada > 0 & 
                                     Modelo_Backtesting$pi_calculada <= 0.0060, 1,
                                   ifelse(Modelo_Backtesting$pi_calculada > 0.0060 & 
                                            Modelo_Backtesting$pi_calculada <= 0.015, 2,
                                          ifelse(Modelo_Backtesting$pi_calculada > 0.015 & 
                                                   Modelo_Backtesting$pi_calculada <= 0.030, 3,
                                                 ifelse(Modelo_Backtesting$pi_calculada > 0.030 & 
                                                          Modelo_Backtesting$pi_calculada <= 0.060, 4,    
                                                        ifelse(Modelo_Backtesting$pi_calculada > 0.060 & 
                                                                 Modelo_Backtesting$pi_calculada <= 0.100, 5,
                                                               ifelse(Modelo_Backtesting$pi_calculada > 0.100 & 
                                                                        Modelo_Backtesting$pi_calculada <= 0.300, 6,
                                                                      ifelse(Modelo_Backtesting$pi_calculada > 0.300 & 
                                                                               Modelo_Backtesting$pi_calculada <= 0.600, 7,
                                                                             ifelse(Modelo_Backtesting$pi_calculada > 0.600 & 
                                                                                      Modelo_Backtesting$pi_calculada <= 0.900, 8,
                                                                                    ifelse(Modelo_Backtesting$pi_calculada > 0.900 & 
                                                                                             Modelo_Backtesting$pi_calculada <= 1.0, 9,"NA")))))))))

Base_grafico <- Modelo_Backtesting %>% 
  group_by(Grupo) %>% 
  summarise(PI_Promedio = mean(pi_calculada)*100,
            conteo = n(),
            Default=sum(Default),
            PI_Real=(sum(Default)/n())*100,
            Porc_Clientes=(n()/length(datos2$Default))*100) %>% 
  ungroup()  

Base_grafico<-as.data.frame(Base_grafico)
Base_grafico

windows()
plot(Base_grafico$Grupo,Base_grafico$PI_Promedio,main="Backtesting",
     ylab="Probabilidad de Incumplimiento (%)",
     ylim=c(0,100),type="overplotted",pch=1,col="blue",lwd=2,xlab="Bandas de Rating",
     cex.lab=1.2)
axis(1, at = c(1:10))

lines(Base_grafico$Grupo,Base_grafico$PI_Real,col="red",type="overplotted",lwd=2)

legend(x=1,y=80,
       legend=c("PI estimada","PI Real"),
       col=c("blue","red"),
       lwd=2)

mean(Modelo_Backtesting$pi_calculada)


sensitivity(Modelo_Backtesting$Default, Modelo_Backtesting$pi_calculada, threshold = 0.50)

specificity(Modelo_Backtesting$Default, Modelo_Backtesting$pi_calculada, threshold = 0.50)


#matriz_backtesting <- optimalCutoff(Modelo_Backtesting$Default, Modelo_Backtesting$pi_calculada)
#sensitivity(Modelo_Backtesting$Default, Modelo_Backtesting$pi_calculada, threshold = matriz_backtesting)
#specificity(Modelo_Backtesting$Default, Modelo_Backtesting$pi_calculada, threshold = matriz_backtesting)

######### GRFICO VALIDACIN ###################################################################

Modelo_Validacion$Grupo2 <- ifelse(Modelo_Validacion$pi_calculada > 0 & 
                                    Modelo_Validacion$pi_calculada <= 0.0060, 1,
                                   ifelse(Modelo_Validacion$pi_calculada > 0.0060 & 
                                            Modelo_Validacion$pi_calculada <= 0.015, 2,
                                          ifelse(Modelo_Validacion$pi_calculada > 0.015 & 
                                                   Modelo_Validacion$pi_calculada <= 0.030, 3,
                                                 ifelse(Modelo_Validacion$pi_calculada > 0.030 & 
                                                          Modelo_Validacion$pi_calculada <= 0.060, 4,    
                                                        ifelse(Modelo_Validacion$pi_calculada > 0.060 & 
                                                                 Modelo_Validacion$pi_calculada <= 0.100, 5,
                                                               ifelse(Modelo_Validacion$pi_calculada > 0.100 & 
                                                                        Modelo_Validacion$pi_calculada <= 0.300, 6,
                                                                      ifelse(Modelo_Validacion$pi_calculada > 0.300 & 
                                                                               Modelo_Validacion$pi_calculada <= 0.600, 7,
                                                                             ifelse(Modelo_Validacion$pi_calculada > 0.600 & 
                                                                                      Modelo_Validacion$pi_calculada <= 0.900, 8,
                                                                                    ifelse(Modelo_Validacion$pi_calculada > 0.900 & 
                                                                                            Modelo_Validacion$pi_calculada <= 1.0, 9,"NA")))))))))
Base_grafico2 <- Modelo_Validacion %>% 
  group_by(Grupo2) %>% 
  summarise(PI_Promedio = mean(pi_calculada)*100,
            conteo = n(),
            Default=sum(Default),
            PI_Real=(sum(Default)/n())*100,
            Porc_Clientes=(n()/length(validacion$Default))*100) %>% 
  ungroup()  

Base_grafico2<-as.data.frame(Base_grafico2)
Base_grafico2

windows()
plot(Base_grafico2$Grupo2,Base_grafico2$PI_Promedio,main="Validacin",
     ylab="Probabilidad de Incumplimiento (%)",
     ylim=c(0,100),type="overplotted",pch=1,col="blue",lwd=2,xlab="Bandas de Rating",
     cex.lab=1.2)
axis(1, at = c(1:10))

lines(Base_grafico2$Grupo2,Base_grafico2$PI_Real,col="red",type="overplotted",lwd=2)

legend(x=1,y=80,
       legend=c("PI estimada","PI Real"),
       col=c("blue","red"),
       lwd=2)

mean(Modelo_Validacion$pi_calculada)


######### GRFICO MODELACIN ###################################################################

Modelo_ajustado$Grupo3 <- ifelse(Modelo_ajustado$pi_calculada > 0 & 
                                   Modelo_ajustado$pi_calculada <= 0.0060, 1,
                                   ifelse(Modelo_ajustado$pi_calculada > 0.0060 & 
                                            Modelo_ajustado$pi_calculada <= 0.015, 2,
                                          ifelse(Modelo_ajustado$pi_calculada > 0.015 & 
                                                   Modelo_ajustado$pi_calculada <= 0.030, 3,
                                                 ifelse(Modelo_ajustado$pi_calculada > 0.030 & 
                                                          Modelo_ajustado$pi_calculada <= 0.060, 4,    
                                                        ifelse(Modelo_ajustado$pi_calculada > 0.060 & 
                                                                 Modelo_ajustado$pi_calculada <= 0.100, 5,
                                                               ifelse(Modelo_ajustado$pi_calculada > 0.100 & 
                                                                        Modelo_ajustado$pi_calculada <= 0.300, 6,
                                                                      ifelse(Modelo_ajustado$pi_calculada > 0.300 & 
                                                                               Modelo_ajustado$pi_calculada <= 0.600, 7,
                                                                             ifelse(Modelo_ajustado$pi_calculada > 0.600 & 
                                                                                      Modelo_ajustado$pi_calculada <= 0.900, 8,
                                                                                    ifelse(Modelo_ajustado$pi_calculada > 0.900 & 
                                                                                             Modelo_ajustado$pi_calculada <= 1.0, 9,"NA")))))))))
Base_grafico3 <- Modelo_ajustado %>% 
  group_by(Grupo3) %>% 
  summarise(PI_Promedio = mean(pi_calculada)*100,
            conteo = n(),
            Default=sum(Default),
            PI_Real=(sum(Default)/n())*100,
            Porc_Clientes=(n()/length(entrenamiento$Default))*100) %>% 
  ungroup()  

Base_grafico3<-as.data.frame(Base_grafico3)
Base_grafico3

windows()
plot(Base_grafico3$Grupo3,Base_grafico3$PI_Promedio,main="Entrenamiento",
     ylab="Probabilidad de Incumplimiento (%)",
     ylim=c(0,100),type="overplotted",pch=1,col="blue",lwd=2,xlab="Bandas de Rating",
     cex.lab=1.2)
axis(1, at = c(1:10))

lines(Base_grafico3$Grupo3,Base_grafico3$PI_Real,col="red",type="overplotted",lwd=2)

legend(x=1,y=80,
       legend=c("PI estimada","PI Real"),
       col=c("blue","red"),
       lwd=2)



######### ADICIONAL #########
Modelo_ajustado2<-entrenamiento[c(5,6,7,8,10,11,12,13,14,16,18)]
str(Modelo_ajustado2)
summary(Modelo_ajustado2)
Modelo_ajustado2$Default<-as.numeric(Modelo_ajustado2$Default)
logit2<- glm(entrenamiento$Default~. ,data=Modelo_ajustado2, family=(binomial(link=logit)))
summary(logit2)


